import { apiConfig } from '@/config/api.config';
import { useManageProfessionContext } from '../hooks/useManageProfessionContext';
import { Alert, useDataGrid } from '@/components';
import { useCallApi } from '@/hooks';
import { getAuth } from '@/auth';
import React, { useCallback, useEffect, useState } from 'react';
import { toast } from 'sonner';
import {
  Dialog,
  DialogBody,
  DialogContent,
  DialogDescription,
  DialogHeader,
  DialogTitle
} from '@/components/ui/dialog';
import { Input } from '@/components/ui/input';
import { Button } from '@/components/ui/button';
import { doSaveLogActivity } from '@/actions/GlobalActions';
import { RefreshCw } from 'lucide-react';

const API_URL = apiConfig.service_master_data;
const EditDialog = () => {
  const { showEditDialog, handleEditDialog, selectedProfession } = useManageProfessionContext();
  const { reload } = useDataGrid();
  const { PutData, GetData } = useCallApi();
  const parsedUser = getAuth()?.user;
  const [isLoading, setIsLoading] = useState(false);
  const [isSubmitting, setIsSubmitting] = useState(false);
  const created_time = new Date();
  const formattedTime = created_time.toISOString().slice(0, 19).replace('T', ' ');
  const [alert, setAlert] = useState({
    show: false,
    message: ''
  });
  const initialState = {
    name: '',
    updated_by: '',
    updated_at: ''
  };
  const [formField, setFormField] = useState(initialState);

  const resetForm = () => {
    setFormField(initialState);
    setAlert({ show: false, message: '' });
  };

  const doUpdateProfession = useCallback(
    async (e: React.FormEvent<HTMLFormElement>) => {
      e.preventDefault();
      setIsSubmitting(true);

      try {
        const response = await PutData(
          `${API_URL}/profession/update/${selectedProfession}`,
          formField
        );

        if (response?.status) {
          resetForm();
          handleEditDialog(false, null);
          toast.success('Success Update Profession');
          reload();

          const createActivity = {
            module: 'Manage Profession',
            description: `Edit Profession => ${selectedProfession}`,
            action: 'U'
          };

          doSaveLogActivity(createActivity);
        } else {
          toast.error('Failed Update Profession');
          setAlert({ show: true, message: response?.message });
        }
      } catch (error) {
        toast.error('Something went wrong, please try again.');
      } finally {
        setIsSubmitting(false);
      }
    },
    [selectedProfession, formField]
  );

  const doFetchData = useCallback(async (id: string) => {
    setIsLoading(true);
    const minDelay = new Promise((resolve) => setTimeout(resolve, 300));
    const fetchData = GetData(`${API_URL}/profession/getdata/${id}`, { id });
    const [response] = await Promise.all([fetchData, minDelay]);

    if (response?.status) {
      setFormField((prev) => ({
        ...prev,
        name: response.data.name
      }));
    } else {
      setFormField(initialState);
    }
    setIsLoading(false);
  }, []);

  const handleUpdate = (e: React.FormEvent<HTMLFormElement>) => {
    e.preventDefault();

    if (formField.name.trim() === '') {
      setAlert({ show: true, message: 'Please fill name field.' });
      return;
    }

    doUpdateProfession(e);
    console.log(formField);
    setAlert({ show: false, message: '' });
  };

  useEffect(() => {
    if (selectedProfession) {
      doFetchData(selectedProfession);
    }
  }, [selectedProfession]);

  useEffect(() => {
    if (showEditDialog) {
      setFormField({
        ...formField,
        updated_by: parsedUser.username,
        updated_at: formattedTime
      });
    }
  }, [formattedTime]);

  useEffect(() => {
    if (showEditDialog === false) {
      resetForm();
    }
  }, [showEditDialog]);

  return (
    <Dialog open={showEditDialog} onOpenChange={(open) => handleEditDialog(open, null)}>
      <DialogContent className="container-fixed max-w-[768px] flex flex-col p-5 overflow-hidden">
        <DialogHeader>
          <DialogTitle>Profession - Update</DialogTitle>
          <DialogDescription></DialogDescription>
        </DialogHeader>
        <DialogBody>
          <div className="flex flex-col">
            {alert.show && (
              <Alert variant="danger">
                <h3>{alert.message}</h3>
              </Alert>
            )}

            {isLoading ? (
              <div className="flex flex-col items-center justify-center p-8">
                <div className="animate-pulse flex space-x-4 w-full">
                  <div className="flex-1 space-y-4 py-1">
                    <div className="h-4 bg-gray-200 rounded w-3/4"></div>
                    <div className="space-y-2">
                      <div className="h-4 bg-gray-200 rounded"></div>
                      <div className="h-4 bg-gray-200 rounded w-5/6"></div>
                    </div>
                  </div>
                </div>
                <p className="mt-4 text-gray-500">Loading Profession Details...</p>
              </div>
            ) : (
              <form onSubmit={handleUpdate}>
                <div className="card-body grid gap-5">
                  <div className="w-full">
                    <div className="flex items-baseline flex-wrap lg:flex-nowrap gap-2.5">
                      <label className="form-label flex items-center gap-1 max-w-56">
                        Name<span className="text-red-500">*</span>
                      </label>
                      <Input
                        className="input"
                        type="text"
                        value={formField.name}
                        onChange={(e) => setFormField({ ...formField, name: e.target.value })}
                      />
                    </div>
                  </div>

                  <div className="flex justify-end">
                    <Button variant="default" type="submit" disabled={isSubmitting}>
                      {isSubmitting ? (
                        <RefreshCw className="animate-spin h-8 w-8 text-white mx-7" />
                      ) : (
                        'Save Changes'
                      )}
                    </Button>
                  </div>
                </div>
              </form>
            )}
          </div>
        </DialogBody>
      </DialogContent>
    </Dialog>
  );
};

export default EditDialog;
